// Code generated by "enumer -type=MediaType -json -text -yaml -sql"; DO NOT EDIT.

//
package mediaTypes

import (
	"database/sql/driver"
	"encoding/json"
	"fmt"
)

const _MediaTypeName = "NAAudioHTMLPDFScoreByzScoreByzEScoreWesternText"

var _MediaTypeIndex = [...]uint8{0, 2, 7, 11, 14, 22, 31, 43, 47}

func (i MediaType) String() string {
	if i < 0 || i >= MediaType(len(_MediaTypeIndex)-1) {
		return fmt.Sprintf("MediaType(%d)", i)
	}
	return _MediaTypeName[_MediaTypeIndex[i]:_MediaTypeIndex[i+1]]
}

var _MediaTypeValues = []MediaType{0, 1, 2, 3, 4, 5, 6, 7}

var _MediaTypeNameToValueMap = map[string]MediaType{
	_MediaTypeName[0:2]:   0,
	_MediaTypeName[2:7]:   1,
	_MediaTypeName[7:11]:  2,
	_MediaTypeName[11:14]: 3,
	_MediaTypeName[14:22]: 4,
	_MediaTypeName[22:31]: 5,
	_MediaTypeName[31:43]: 6,
	_MediaTypeName[43:47]: 7,
}

// MediaTypeString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func MediaTypeString(s string) (MediaType, error) {
	if val, ok := _MediaTypeNameToValueMap[s]; ok {
		return val, nil
	}
	return 0, fmt.Errorf("%s does not belong to MediaType values", s)
}

// MediaTypeValues returns all values of the enum
func MediaTypeValues() []MediaType {
	return _MediaTypeValues
}

// IsAMediaType returns "true" if the value is listed in the enum definition. "false" otherwise
func (i MediaType) IsAMediaType() bool {
	for _, v := range _MediaTypeValues {
		if i == v {
			return true
		}
	}
	return false
}

// MarshalJSON implements the json.Marshaler interface for MediaType
func (i MediaType) MarshalJSON() ([]byte, error) {
	return json.Marshal(i.String())
}

// UnmarshalJSON implements the json.Unmarshaler interface for MediaType
func (i *MediaType) UnmarshalJSON(data []byte) error {
	var s string
	if err := json.Unmarshal(data, &s); err != nil {
		return fmt.Errorf("MediaType should be a string, got %s", data)
	}

	var err error
	*i, err = MediaTypeString(s)
	return err
}

// MarshalText implements the encoding.TextMarshaler interface for MediaType
func (i MediaType) MarshalText() ([]byte, error) {
	return []byte(i.String()), nil
}

// UnmarshalText implements the encoding.TextUnmarshaler interface for MediaType
func (i *MediaType) UnmarshalText(text []byte) error {
	var err error
	*i, err = MediaTypeString(string(text))
	return err
}

// MarshalYAML implements a YAML Marshaler for MediaType
func (i MediaType) MarshalYAML() (interface{}, error) {
	return i.String(), nil
}

// UnmarshalYAML implements a YAML Unmarshaler for MediaType
func (i *MediaType) UnmarshalYAML(unmarshal func(interface{}) error) error {
	var s string
	if err := unmarshal(&s); err != nil {
		return err
	}

	var err error
	*i, err = MediaTypeString(s)
	return err
}

func (i MediaType) Value() (driver.Value, error) {
	return i.String(), nil
}

func (i *MediaType) Scan(value interface{}) error {
	if value == nil {
		return nil
	}

	str, ok := value.(string)
	if !ok {
		bytes, ok := value.([]byte)
		if !ok {
			return fmt.Errorf("value is not a byte slice")
		}

		str = string(bytes[:])
	}

	val, err := MediaTypeString(str)
	if err != nil {
		return err
	}

	*i = val
	return nil
}
